<?php

namespace Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram;

/**
 * Class representing TradeProductType
 *
 * XSD Type: TradeProductType
 */
class TradeProductType
{

    /**
     * @var \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $globalID
     */
    private $globalID = null;

    /**
     * @var \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $sellerAssignedID
     */
    private $sellerAssignedID = null;

    /**
     * @var \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $buyerAssignedID
     */
    private $buyerAssignedID = null;

    /**
     * @var string $name
     */
    private $name = null;

    /**
     * @var string $description
     */
    private $description = null;

    /**
     * @var \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductCharacteristicType[] $applicableProductCharacteristic
     */
    private $applicableProductCharacteristic = [
        
    ];

    /**
     * @var \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductClassificationType[] $designatedProductClassification
     */
    private $designatedProductClassification = [
        
    ];

    /**
     * @var \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\TradeCountryType $originTradeCountry
     */
    private $originTradeCountry = null;

    /**
     * Gets as globalID
     *
     * @return \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType
     */
    public function getGlobalID()
    {
        return $this->globalID;
    }

    /**
     * Sets a new globalID
     *
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $globalID
     * @return self
     */
    public function setGlobalID(?\Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $globalID = null)
    {
        $this->globalID = $globalID;
        return $this;
    }

    /**
     * Gets as sellerAssignedID
     *
     * @return \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType
     */
    public function getSellerAssignedID()
    {
        return $this->sellerAssignedID;
    }

    /**
     * Sets a new sellerAssignedID
     *
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $sellerAssignedID
     * @return self
     */
    public function setSellerAssignedID(?\Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $sellerAssignedID = null)
    {
        $this->sellerAssignedID = $sellerAssignedID;
        return $this;
    }

    /**
     * Gets as buyerAssignedID
     *
     * @return \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType
     */
    public function getBuyerAssignedID()
    {
        return $this->buyerAssignedID;
    }

    /**
     * Sets a new buyerAssignedID
     *
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $buyerAssignedID
     * @return self
     */
    public function setBuyerAssignedID(?\Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\udt\IDType $buyerAssignedID = null)
    {
        $this->buyerAssignedID = $buyerAssignedID;
        return $this;
    }

    /**
     * Gets as name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets a new name
     *
     * @param  string $name
     * @return self
     */
    public function setName($name)
    {
        $this->name = $name;
        return $this;
    }

    /**
     * Gets as description
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * Sets a new description
     *
     * @param  string $description
     * @return self
     */
    public function setDescription($description)
    {
        $this->description = $description;
        return $this;
    }

    /**
     * Adds as applicableProductCharacteristic
     *
     * @return self
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductCharacteristicType $applicableProductCharacteristic
     */
    public function addToApplicableProductCharacteristic(\Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductCharacteristicType $applicableProductCharacteristic)
    {
        $this->applicableProductCharacteristic[] = $applicableProductCharacteristic;
        return $this;
    }

    /**
     * isset applicableProductCharacteristic
     *
     * @param  int|string $index
     * @return bool
     */
    public function issetApplicableProductCharacteristic($index)
    {
        return isset($this->applicableProductCharacteristic[$index]);
    }

    /**
     * unset applicableProductCharacteristic
     *
     * @param  int|string $index
     * @return void
     */
    public function unsetApplicableProductCharacteristic($index)
    {
        unset($this->applicableProductCharacteristic[$index]);
    }

    /**
     * Gets as applicableProductCharacteristic
     *
     * @return \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductCharacteristicType[]
     */
    public function getApplicableProductCharacteristic()
    {
        return $this->applicableProductCharacteristic;
    }

    /**
     * Sets a new applicableProductCharacteristic
     *
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductCharacteristicType[] $applicableProductCharacteristic
     * @return self
     */
    public function setApplicableProductCharacteristic(?array $applicableProductCharacteristic = null)
    {
        $this->applicableProductCharacteristic = $applicableProductCharacteristic;
        return $this;
    }

    /**
     * Adds as designatedProductClassification
     *
     * @return self
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductClassificationType $designatedProductClassification
     */
    public function addToDesignatedProductClassification(\Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductClassificationType $designatedProductClassification)
    {
        $this->designatedProductClassification[] = $designatedProductClassification;
        return $this;
    }

    /**
     * isset designatedProductClassification
     *
     * @param  int|string $index
     * @return bool
     */
    public function issetDesignatedProductClassification($index)
    {
        return isset($this->designatedProductClassification[$index]);
    }

    /**
     * unset designatedProductClassification
     *
     * @param  int|string $index
     * @return void
     */
    public function unsetDesignatedProductClassification($index)
    {
        unset($this->designatedProductClassification[$index]);
    }

    /**
     * Gets as designatedProductClassification
     *
     * @return \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductClassificationType[]
     */
    public function getDesignatedProductClassification()
    {
        return $this->designatedProductClassification;
    }

    /**
     * Sets a new designatedProductClassification
     *
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\ProductClassificationType[] $designatedProductClassification
     * @return self
     */
    public function setDesignatedProductClassification(?array $designatedProductClassification = null)
    {
        $this->designatedProductClassification = $designatedProductClassification;
        return $this;
    }

    /**
     * Gets as originTradeCountry
     *
     * @return \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\TradeCountryType
     */
    public function getOriginTradeCountry()
    {
        return $this->originTradeCountry;
    }

    /**
     * Sets a new originTradeCountry
     *
     * @param  \Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\TradeCountryType $originTradeCountry
     * @return self
     */
    public function setOriginTradeCountry(?\Itdatex\Rechnungseingang\Vendor\horstoeko\zugferd\entities\en16931\ram\TradeCountryType $originTradeCountry = null)
    {
        $this->originTradeCountry = $originTradeCountry;
        return $this;
    }
}
